Index: uspace/srv/net/tl/udp/udp_module.c
===================================================================
--- uspace/srv/net/tl/udp/udp_module.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ uspace/srv/net/tl/udp/udp_module.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -40,26 +40,19 @@
 #include <async.h>
 #include <stdio.h>
-
 #include <ipc/ipc.h>
 #include <ipc/services.h>
 
-#include "../../err.h"
-#include "../../modules.h"
-
-#include "../../structures/packet/packet.h"
-
-#include "../../include/net_interface.h"
+#include <net_err.h>
+#include <net_modules.h>
+#include <packet/packet.h>
+#include <net_interface.h>
+#include <tl_local.h>
 
 #include "udp.h"
 #include "udp_module.h"
 
-/** UDP module name.
+/** UDP module global data.
  */
-#define NAME	"UDP protocol"
-
-/** Prints the module name.
- *  @see NAME
- */
-void module_print_name(void);
+extern udp_globals_t	udp_globals;
 
 /** Starts the UDP module.
@@ -70,25 +63,5 @@
  *  @returns Other error codes as defined for the REGISTER_ME() macro function.
  */
-int module_start(async_client_conn_t client_connection);
-
-/** Processes the UDP message.
- *  @param[in] callid The message identifier.
- *  @param[in] call The message parameters.
- *  @param[out] answer The message answer parameters.
- *  @param[out] answer_count The last parameter for the actual answer in the answer parameter.
- *  @returns EOK on success.
- *  @returns Other error codes as defined for the udp_message() function.
- */
-int module_message(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count);
-
-/** UDP module global data.
- */
-extern udp_globals_t	udp_globals;
-
-void module_print_name(void){
-	printf("%s", NAME);
-}
-
-int module_start(async_client_conn_t client_connection){
+int tl_module_start_standalone(async_client_conn_t client_connection){
 	ERROR_DECLARE;
 
@@ -113,6 +86,14 @@
 }
 
-int module_message(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
-	return udp_message(callid, call, answer, answer_count);
+/** Processes the UDP message.
+ *  @param[in] callid The message identifier.
+ *  @param[in] call The message parameters.
+ *  @param[out] answer The message answer parameters.
+ *  @param[out] answer_count The last parameter for the actual answer in the answer parameter.
+ *  @returns EOK on success.
+ *  @returns Other error codes as defined for the udp_message() function.
+ */
+int tl_module_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
+	return udp_message_standalone(callid, call, answer, answer_count);
 }
 
Index: uspace/srv/net/tl/udp/udp_module.h
===================================================================
--- uspace/srv/net/tl/udp/udp_module.h	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ uspace/srv/net/tl/udp/udp_module.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -47,5 +47,5 @@
  *  @returns ENOMEM if there is not enough memory left.
  */
-int udp_initialize(async_client_conn_t client_connection);
+extern int udp_initialize(async_client_conn_t client_connection);
 
 /** Processes the UDP message.
@@ -59,5 +59,5 @@
  *  @see IS_NET_UDP_MESSAGE()
  */
-int udp_message(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count);
+extern int udp_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count);
 
 #endif
Index: uspace/srv/ns/ns.c
===================================================================
--- uspace/srv/ns/ns.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ uspace/srv/ns/ns.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -55,8 +55,8 @@
 static void *klogaddr = NULL;
 
-static void get_as_area(ipc_callid_t callid, ipc_call_t *call, void *ph_addr,
+static void get_as_area(ipc_callid_t callid, ipc_call_t *call, void *faddr,
     size_t pages, void **addr)
 {
-	if (ph_addr == NULL) {
+	if ((faddr == NULL) || (pages == 0)) {
 		ipc_answer_0(callid, ENOENT);
 		return;
@@ -71,5 +71,5 @@
 		}
 		
-		if (physmem_map(ph_addr, *addr, pages,
+		if (physmem_map(faddr, *addr, pages,
 		    AS_AREA_READ | AS_AREA_CACHEABLE) != 0) {
 			ipc_answer_0(callid, ENOENT);
@@ -81,4 +81,32 @@
 }
 
+static void setup_clock_area(ipc_callid_t callid, ipc_call_t *call, void **addr)
+{
+	uintptr_t faddr;
+	int err = sysinfo_get_value("clock.faddr", &faddr);
+	
+	if (err != EOK)
+		ipc_answer_0(callid, err);
+	
+	get_as_area(callid, call, (void *) faddr, 1, addr);
+}
+
+static void setup_klog_area(ipc_callid_t callid, ipc_call_t *call, void **addr)
+{
+	uintptr_t faddr;
+	int err = sysinfo_get_value("klog.faddr", &faddr);
+	
+	if (err != EOK)
+		ipc_answer_0(callid, err);
+	
+	size_t pages;
+	err = sysinfo_get_value("klog.pages", &pages);
+	
+	if (err != EOK)
+		ipc_answer_0(callid, err);
+	
+	get_as_area(callid, call, (void *) faddr, pages, addr);
+}
+
 int main(int argc, char **argv)
 {
@@ -97,5 +125,5 @@
 		return rc;
 	
-	printf(NAME ": Accepting connections\n");
+	printf("%s: Accepting connections\n", NAME);
 	
 	while (true) {
@@ -113,12 +141,8 @@
 			switch (IPC_GET_ARG3(call)) {
 			case SERVICE_MEM_REALTIME:
-				get_as_area(callid, &call,
-				    (void *) sysinfo_value("clock.faddr"),
-				    1, &clockaddr);
+				setup_clock_area(callid, &call, &clockaddr);
 				break;
 			case SERVICE_MEM_KLOG:
-				get_as_area(callid, &call,
-				    (void *) sysinfo_value("klog.faddr"),
-				    sysinfo_value("klog.pages"), &klogaddr);
+				setup_klog_area(callid, &call, &klogaddr);
 				break;
 			default:
Index: uspace/srv/taskmon/taskmon.c
===================================================================
--- uspace/srv/taskmon/taskmon.c	(revision 95319bd04e17f7e1bb127fdbbfb754cd00dda2b6)
+++ uspace/srv/taskmon/taskmon.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -44,4 +44,5 @@
 #include <macros.h>
 #include <errno.h>
+#include <str_error.h>
 
 #define NAME  "taskmon"
@@ -96,7 +97,9 @@
 	}
 	putchar('\n');
-
-	if (!task_spawn(fname, argv))
-		printf(NAME ": Error spawning taskdump.\n", fname);
+	
+	int err;
+	if (!task_spawn(fname, argv, &err))
+		printf("%s: Error spawning %s (%s).\n", NAME, fname,
+		    str_error(err));
 }
 
